.\" Copyright (c) 1980, 1990, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by the University of
.\"	California, Berkeley and its contributors.
.\" 4. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)checknr.1	8.1 (Berkeley) 6/6/93
.\"
.Dd June 6, 1993
.Dt CHECKNR 1
.Os BSD 4
.Sh NAME
.Nm checknr
.Nd check nroff/troff files
.Sh SYNOPSIS
.Nm checknr
.Op Fl a Ns Ar \&.x1.y1.x2.y2. ... \&.xn.yn
.Op Fl c Ns Ar \&.x1.x2.x3 ... \&.xn
.Op Fl s
.Op Fl f
.Ar file
.Sh DESCRIPTION
.Nm Checknr
checks a list of
.Xr nroff 1
or
.Xr troff 1
input files for certain kinds of errors
involving mismatched opening and closing delimiters
and unknown commands.
If no files are specified,
.Nm checknr
checks the standard input.
.Pp
Options:
.Bl -tag -width Ds
.It Fl a
Add additional pairs of macros to the list of known macros.
This must be followed by groups of six characters, each group defining
a pair of macros.
The six characters are
a period,
the first macro name,
another period,
and the second macro name.
For example, to define a pair .BS and .ES, use
.Sq Li \-a.BS.ES
.It Fl c
Define commands which would otherwise be complained about
as undefined.
.It Fl f
Request
.Nm checknr
to ignore
.Ql \ef
font changes.
.It Fl s
Ignore
.Ql \es
size changes.
.El
.Pp
Delimiters checked are:
.Bl -enum
.It
Font changes using \efx ... \efP.
.It
Size changes using \esx ... \es0.
.It
Macros that come in open ... close forms, for example,
the .TS and .TE macros which must always come in pairs.
.El
.Pp
.Nm Checknr
is intended for use on documents that are prepared with
.Nm checknr
in mind, much the same as
.Xr lint 1 .
It expects a certain document writing style for
.Ql \ef
and
.Ql \es
commands,
in that each
.Ql \efx
must be terminated with
.Ql \efP
and
each
.Ql \esx
must be terminated with
.Ql \es0 .
While it will work to directly go into the next font or explicitly
specify the original font or point size,
and many existing documents actually do this,
such a practice will produce complaints from
.Nm checknr .
Since it is probably better to use the
.Ql \efP
and
.Ql \es0
forms anyway,
you should think of this as a contribution to your document
preparation style.
.Pp
.Nm Checknr
knows about the
.Xr ms 7
and
.Xr me 7
macro packages.
.Sh SEE ALSO
.Xr nroff 1 ,
.Xr troff 1 ,
.Xr me 7 ,
.Xr ms 7
.\" .Xr checkeq 1 ,
.Sh DIAGNOSTICS
.Bd -ragged -compact
Complaints about unmatched delimiters.
Complaints about unrecognized commands.
Various complaints about the syntax of commands.
.Ed
.Sh BUGS
There is no way to define a 1 character macro name using
.Fl a .
.Pp
Does not correctly recognize certain reasonable constructs,
such as conditionals.
.Sh HISTORY
The
.Nm
command appeared in 
.Bx 4.0 .
